"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const node_path_1 = require("node:path");
const loader = async function (source) {
    const options = this.getOptions();
    this.addBuildDependency(this.resource);
    const matches = source.matchAll(/@asset\(['"](.*?)['"]\)/g);
    if (matches) {
        await Promise.all([...matches].map(async ([match, request]) => {
            const absolutePath = (0, node_path_1.join)(this.rootContext, request);
            this.addBuildDependency(absolutePath);
            const resolvedPath = await this.importModule(request, {
                publicPath: options?.publicPath ?? ``,
            });
            source = source.replace(match, resolvedPath);
        }));
    }
    return source;
};
exports.default = loader;
